"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
class ContextStoreProvider extends react_1.default.Component {
    constructor(props) {
        super(props);
        this.state = { store: props.store };
    }
    componentDidMount() {
        this.storeSubscription = this.props.store.subject.subscribe((data) => {
            this.setState({
                store: Object.assign({}, this.state.store, { data }),
            });
        });
    }
    componentWillUnmount() {
        if (this.storeSubscription) {
            this.storeSubscription.unsubscribe();
        }
    }
    render() {
        const { children, context: { Provider }, } = this.props;
        return (react_1.default.createElement(Provider, { value: this.state.store }, children));
    }
}
exports.default = ContextStoreProvider;
//# sourceMappingURL=context-store-provider.js.map