"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const rxjs_1 = require("rxjs");
exports.createContextStore = ({ data, methods }) => {
    const appliedMethods = {};
    const subject = new rxjs_1.Subject();
    const store = {
        data,
        subject,
        methods: appliedMethods,
    };
    Object.keys(methods).forEach((key) => {
        appliedMethods[key] = function () {
            const method = methods[key];
            const methodReturn = method.apply(store, Array.from(arguments));
            subject.next(data);
            return methodReturn;
        };
    });
    return Object.seal(store);
};
exports.default = exports.createContextStore;
//# sourceMappingURL=create-context-store.js.map